**Danger:** The implicit flow is **not supported** for MCP, UCP, and Agent-driven flows. It is generally discouraged for all new integrations due to security considerations. Use the [authorization code flow](https://developers.google.com/identity/account-linking/oauth-linking?oauth=code) instead.

To support the OAuth 2.0 *implicit* flow, your service makes an authorization
endpoint available by HTTPS. This endpoint is responsible for authentication and
obtaining consent from users for data access. The authorization endpoint
presents a sign-in UI to your users that aren't already signed in and records
consent to the requested access.

When a Google application needs to call one of your service's authorized APIs,
Google uses this endpoint to get permission from your users to call these APIs
on their behalf.

### Google Account Linking: OAuth Implicit Flow

The following sequence diagram details interactions between the User, Google,
and your service's endpoints.
User Google App / Browser Your Auth Endpoint 1. User initiates linking 2. Redirect to Auth Endpoint (GET) client_id, redirect_uri, state, scope 3. Display Sign-in \& Consent Screen 4. User Authenticates \& Grants Consent 5. Redirect back to Google with Token (GET) access_token, state 6. Store user tokens 7. Access user resources **Figure 1.** The sequence of events in the OAuth 2.0 Implicit flow for Google Account Linking.

### Roles and responsibilities

The following table defines the roles and responsibilities of actors in the
Google Account Linking (GAL) OAuth Implicit flow. Note that in GAL, Google acts
as the OAuth **Client** , while your service acts as the
**Identity/Service Provider**.

| Actor / Component | GAL Role | Responsibilities |
|---|---|---|
| **Google App / Server** | OAuth Client | Initiates the flow, receives the access token using a browser redirect, and securely stores it to access your service's APIs. |
| **Your Authorization Endpoint** | Authorization Server | Authenticates your users, obtains their consent, and issues long-lived access tokens directly to Google. |
| **Google Redirect URI** | Callback Endpoint | Receives the user redirect from your authorization service with the `access_token` and `state` values in the URL fragment. |

A typical OAuth 2.0 implicit flow session initiated by Google has the
following flow:

1. Google opens your authorization endpoint in the user's browser. The user signs in, if not signed in already, and grants Google permission to access their data with your API, if they haven't already granted permission.
2. Your service creates an *access token* and returns it to Google. To do so, redirect the user's browser back to Google with the access token attached to the request.
3. Google calls your service's APIs and attaches the access token with each request. Your service verifies that the access token grants Google authorization to access the API and then completes the API call.

## Implementation Recipe

Follow these steps to implement the Implicit flow.

### Step 1: Handle authorization requests

When Google initiates account linking, it redirects the user to your authorization endpoint. For detailed protocol contracts and parameter requirements, see the [Authorization Endpoint](https://developers.google.com/identity/account-linking/your-api-reference#authorization-endpoint).

To handle the request, perform the following actions:

1. **Validate the request**:

   - Confirm that the `client_id` matches the Client ID assigned to Google.
   - Confirm that the `redirect_uri` matches the expected Google redirect URL: `none
     https://oauth-redirect.googleusercontent.com/r/YOUR_PARTNER_ID
     https://oauth-redirect-sandbox.googleusercontent.com/r/YOUR_PARTNER_ID`
   - Verify that `response_type` is `token`.
2. **Authenticate the user**:

   - Check if the user is signed in to your service.
   - If the user is not signed in, prompt them to complete your sign-in or sign-up flow.
3. **Generate access token**:

   - Create a unique, non-guessable access token associated with the user and client.
4. **Redirect back to Google**:

   - Redirect the browser to the URL provided in `redirect_uri`.
   - Append the following parameters in the **URL fragment** (hash):
     - `access_token`: The access token you generated.
     - `token_type`: Must be `bearer`.
     - `state`: The unmodified state value received from Google.

##### Handle userinfo requests

The [userinfo endpoint](https://openid.net/specs/openid-connect-core-1_0.html#userinfo) is an OAuth 2.0 protected resource that return claims about the linked user. Implementing and hosting the userinfo endpoint is optional, except for the following use cases:

- [Linked Account Sign-In](https://developers.google.com/identity/one-tap/android/linked-account-signin) with Google One Tap.
- [Frictionless subscription](https://www.youtube.com/watch?v=ARuf97ncE4w) on AndroidTV.

After the access token has been successfully retrieved from your token endpoint, Google sends a request to your userinfo endpoint to retrieve basic profile information about the linked user.

| userinfo endpoint request headers ||
|---|---|
| `Authorization header` | The access token of type Bearer. |

For example, if your userinfo endpoint is available at
`https://myservice.example.com/userinfo`, a request might look like the following:

```
GET /userinfo HTTP/1.1
Host: myservice.example.com
Authorization: Bearer ACCESS_TOKEN
```

For your userinfo endpoint to handle requests, do the following steps:

1. Extract access token from the Authorization header and return information for the user associated with the access token.
2. If the access token is invalid, return an HTTP 401 Unauthorized error with using the `WWW-Authenticate` Response Header. Below is an example of a userinfo error response:

   ```
   HTTP/1.1 401 Unauthorized
   WWW-Authenticate: error="invalid_token",
   error_description="The Access Token expired"
   ```
   If a 401 Unauthorized, or any other unsuccessful error response is returned during the linking process, the error will be non-recoverable, the retrieved token will be discarded and the user will have to initiate the linking process again.
3. If the access token is valid, return and HTTP 200 response with the following JSON object in the body of the HTTPS
   response:

   ```
   {
   "sub": "USER_UUID",
   "email": "EMAIL_ADDRESS",
   "given_name": "FIRST_NAME",
   "family_name": "LAST_NAME",
   "name": "FULL_NAME",
   "picture": "PROFILE_PICTURE",
   }
   ```
   If your userinfo endpoint returns an HTTP 200 success response, the retrieved token and claims are registered against the user's Google account.

   <br />

   | userinfo endpoint response ||
   |---|---|
   | `sub` | A unique ID that identifies the user in your system. |
   | `email` | Email address of the user. |
   | `given_name` | **Optional:** First name of the user. |
   | `family_name` | **Optional:** Last name of the user. |
   | `name` | **Optional:** Full name of the user. |
   | `picture` | **Optional:** Profile picture of the user. |